#!/bin/sh

sudo apt install -y openssh-server htop hwinfo

sudo snap install cmake --classic 

cmake --version

sudo apt install -y build-essential
sudo apt install -y crossbuild-essential-arm64
sudo apt install -y crossbuild-essential-armhf

sudo apt install -y g++-10 libomp-dev libomp5 libboost-all-dev librange-v3-dev 
sudo apt install -y libc++-dev libc++1 libc++abi-dev libc++abi1 libpthread-stubs0-dev libpthread-workqueue-dev

sudo apt install -y gcc-10-arm-linux-gnueabi g++-10-arm-linux-gnueabi
sudo apt install -y gcc-10-arm-linux-gnueabihf g++-10-arm-linux-gnueabihf

sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-9 1
sudo update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-10 2

sudo update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-9 1
sudo update-alternatives --install /usr/bin/g++ g++ /usr/bin/g++-10 2

sudo update-alternatives --install /usr/bin/cc cc /usr/bin/gcc 3
sudo update-alternatives --set cc /usr/bin/gcc

sudo update-alternatives --install /usr/bin/c++ c++ /usr/bin/g++ 3
sudo update-alternatives --set c++ /usr/bin/g++

sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-gcc arm-linux-gnueabihf-gcc /usr/bin/arm-linux-gnueabihf-gcc-9 1
sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-gcc arm-linux-gnueabihf-gcc /usr/bin/arm-linux-gnueabihf-gcc-10 2

sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-g++ arm-linux-gnueabihf-g++ /usr/bin/arm-linux-gnueabihf-g++-9 1
sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-g++ arm-linux-gnueabihf-g++ /usr/bin/arm-linux-gnueabihf-g++-10 2

sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-cc arm-linux-gnueabihf-cc /usr/bin/arm-linux-gnueabihf-gcc 3
sudo update-alternatives --set arm-linux-gnueabihf-cc /usr/bin/arm-linux-gnueabihf-gcc

sudo update-alternatives --install /usr/bin/arm-linux-gnueabihf-c++ arm-linux-gnueabihf-c++ /usr/bin/arm-linux-gnueabihf-g++ 3
sudo update-alternatives --set arm-linux-gnueabihf-c++ /usr/bin/arm-linux-gnueabihf-g++

gcc --version && g++ --version

arm-linux-gnueabihf-gcc --version && arm-linux-gnueabihf-g++ --version

cd /opt
rm -rf triSYCL

git clone --recurse-submodules https://github.com/triSYCL/triSYCL

cd /opt/triSYCL

export CPLUS_INCLUDE_PATH=/usr/include/c++/10
env CPLUS_INCLUDE_PATH=/usr/include/c++/10
sudo echo "export CPLUS_INCLUDE_PATH=/usr/include/c++/10" >> /root/.bashrc

sudo rsync -r ./ include/ /usr/include/c++/10/

rm -rf /opt/triSYCL

cd ~

echo "\n*** CONGRATULATIONS!!! YOU'RE ALL SET! ***\n\n"
echo "*** BUILDING HELLO.CPP FOR X86_64 AND RASPI4B+ ***\n\n"

g++ -std=c++17 -o hello hello.cpp -lpthread -lstdc++
arm-linux-gnueabihf-g++ -std=c++17 -o hello_rpi4b hello.cpp -lpthread -lstdc++

echo "*** RUNNING PARALLEL CL/TRISYCL EXECUTABLE ON X86_64 ***\n"

./hello > output.txt && cat output.txt && rm -f output.txt

echo "\n*** SUCCESS!!! ***\n\n"